//******************************************************************
//      ENCODER library
//                                              Chi-Mou Chao 4/25/98
//******************************************************************
#include <stdio.h>
#include <stdlib.h> 
#include <conio.h>
#include <dos.h>
#include "oenc3.h"

//-------------- hardware -------------------------
#define RD1   0x00    //R
#define RD2   0x01    //R
#define RD3   0x02    //R
#define RD4   0x03    //R
#define WR1   0x00    //W
#define WR2   0x01    //W
#define WR3   0x02    //W

//####################################################################
//####################################################################
//********************************************************************
void TEncoder::ENC3_SELECT(unsigned int address)
{
  encoder_base = address;
}
//********************************************************************
void TEncoder::ENC3_INIT_CARD(unsigned char x_mode,
                    unsigned char y_mode,
                    unsigned char z_mode)
{
  encoder_ctrl1 = 0x07 | x_mode;
  encoder_ctrl2 = 0x07 | y_mode;
  encoder_ctrl3 = 0x07 | z_mode;

  //reset HCTL-3016;
  encoder_ctrl1 &= 0xFE;
  encoder_ctrl2 &= 0xFE;
  encoder_ctrl3 &= 0xFE;
  outportb(encoder_base + WR1, encoder_ctrl1);
  outportb(encoder_base + WR2, encoder_ctrl2);
  outportb(encoder_base + WR3, encoder_ctrl3);

  encoder_ctrl1 |= 0x01;
  encoder_ctrl2 |= 0x01;
  encoder_ctrl3 |= 0x01;
  outportb(encoder_base + WR1, encoder_ctrl1);
  outportb(encoder_base + WR2, encoder_ctrl2);
  outportb(encoder_base + WR3, encoder_ctrl3);

}
//********************************************************************
unsigned int TEncoder::ENC3_GET_ENCODER(unsigned char axis)
{
unsigned int value;

   switch (axis)
   {
      case X_axis:
                  encoder_ctrl1 &= 0xF9;  //1111 1001 low byte
                  outportb(encoder_base + WR1, encoder_ctrl1);
                  value = inportb(encoder_base + RD1);

                  encoder_ctrl1 |= 0x04;  //0000 0100 high byte
                  outportb(encoder_base + WR1, encoder_ctrl1);
                  value += inportb(encoder_base + RD1)*256;

                  encoder_ctrl1 |= 0x06;  //0000 0110
                  outportb(encoder_base + WR1, encoder_ctrl1);
                  break;
      case Y_axis:
                  encoder_ctrl2 &= 0xF9;  //1111 1001 low byte
                  outportb(encoder_base + WR2, encoder_ctrl2);  
                  value = inportb(encoder_base + RD2);

                  encoder_ctrl2 |= 0x04;  //0000 0100 high byte
                  outportb(encoder_base + WR2, encoder_ctrl2);
                  value += inportb(encoder_base + RD2)*256;

                  encoder_ctrl2 |= 0x06;  //0000 0110 
                  outportb(encoder_base + WR2, encoder_ctrl2);
                  break;
      case Z_axis:
                  encoder_ctrl3 &= 0xF9;  //1111 1001 low byte
                  outportb(encoder_base + WR3, encoder_ctrl3);  
                  value = inportb(encoder_base + RD3);

                  encoder_ctrl3 |= 0x04;  //0000 0100 high byte
                  outportb(encoder_base + WR3, encoder_ctrl3);
                  value += inportb(encoder_base + RD3)*256;

                  encoder_ctrl3 |= 0x06;  //0000 0110 
                  outportb(encoder_base + WR3, encoder_ctrl3);
                  break;
      default : break;
   }

   return value;
}
//********************************************************************
void TEncoder::ENC3_RESET_ENCODER(unsigned char axis)
{
   switch (axis)
   {
      case X_axis: 
                  encoder_ctrl1 &= 0xFE;  //1111 1110 
                  outportb(encoder_base + WR1, encoder_ctrl1);

                  encoder_ctrl1 |= 0x01;  //0000 0001
                  outportb(encoder_base + WR1, encoder_ctrl1);
                  break;
      case Y_axis:
                  encoder_ctrl2 &= 0xFE;  //1111 1110
                  outportb(encoder_base + WR2, encoder_ctrl2);

                  encoder_ctrl2 |= 0x01;  //0000 0001
                  outportb(encoder_base + WR2, encoder_ctrl2);
                  break;
      case Z_axis:
                  encoder_ctrl3 &= 0xFE;  //1111 1110
                  outportb(encoder_base + WR3, encoder_ctrl3);

                  encoder_ctrl3 |= 0x01;  //0000 0001
                  outportb(encoder_base + WR3, encoder_ctrl3);
                  break;
      default : break;
   }
}
//********************************************************************
unsigned char TEncoder::ENC3_GET_INDEX()
{
unsigned char index;

  index = 0x07 & inportb(encoder_base + RD4);
  return index;
}
